diff --git a/src/tim/vx/ops/conv2d_test.cc b/src/tim/vx/ops/conv2d_test.cc
index 77db127..5332cf0 100644
--- a/src/tim/vx/ops/conv2d_test.cc
+++ b/src/tim/vx/ops/conv2d_test.cc
@@ -1829,32 +1832,34 @@ TEST(Conv2d, shape_4_2_1_1_int16_DFPQuantizedTest) {
   tim::vx::ShapeType bias_shape({weight_shape[3]});
   tim::vx::ShapeType output_shape(
       {4, 2, weight_shape[3], input_shape[3]});  //whcn
-  int8_t fl_input = 9, fl_weight = 8, fl_bias = 17,fl_output = 8;
+  int8_t fl_input = 9, fl_weight = 8, fl_bias = 17, fl_output = 8;
 
-  tim::vx::Quantization quant_input(tim::vx::QuantType::DYNAMIC_FIXED_POINT, fl_input);
-  tim::vx::Quantization quant_weight(tim::vx::QuantType::DYNAMIC_FIXED_POINT, fl_weight);
-  tim::vx::Quantization quant_bias(tim::vx::QuantType::DYNAMIC_FIXED_POINT, fl_bias);
-  tim::vx::Quantization quant_output(tim::vx::QuantType::DYNAMIC_FIXED_POINT, fl_output);
+  tim::vx::Quantization quant_input(tim::vx::QuantType::DYNAMIC_FIXED_POINT,
+                                    fl_input);
+  tim::vx::Quantization quant_weight(tim::vx::QuantType::DYNAMIC_FIXED_POINT,
+                                     fl_weight);
+  tim::vx::Quantization quant_bias(tim::vx::QuantType::DYNAMIC_FIXED_POINT,
+                                   fl_bias);
+  tim::vx::Quantization quant_output(tim::vx::QuantType::DYNAMIC_FIXED_POINT,
+                                     fl_output);
   tim::vx::TensorSpec input_spec(tim::vx::DataType::INT16, input_shape,
-                                     tim::vx::TensorAttribute::INPUT,
-                                     quant_input);
+                                 tim::vx::TensorAttribute::INPUT, quant_input);
   tim::vx::TensorSpec weight_spec(tim::vx::DataType::INT16, weight_shape,
-                                      tim::vx::TensorAttribute::CONSTANT,
-                                      quant_weight);
+                                  tim::vx::TensorAttribute::CONSTANT,
+                                  quant_weight);
   tim::vx::TensorSpec bias_spec(tim::vx::DataType::INT64, bias_shape,
-                                      tim::vx::TensorAttribute::CONSTANT,
-                                      quant_bias);
+                                tim::vx::TensorAttribute::CONSTANT, quant_bias);
   tim::vx::TensorSpec output_spec(tim::vx::DataType::INT16, output_shape,
-                                      tim::vx::TensorAttribute::OUTPUT,
-                                      quant_output);
+                                  tim::vx::TensorAttribute::OUTPUT,
+                                  quant_output);
   // Input data  nchw
-  std::vector<float> input_data_float= {
+  std::vector<float> input_data_float = {
       1, 1, 1, 1,  // row = 1
       2, 2, 3, 2   // row = 2
   };
 
   // weight data   oihw
-  std::vector<float> weight_data_float= {
+  std::vector<float> weight_data_float = {
       1,  2,  3,  4,  //first 2x2 filter
       -1, 1,  -1, 1,  // second 2x2 filter
       -1, -1, 1,  1,  // third 2x2 filter
@@ -1865,24 +1870,18 @@ TEST(Conv2d, shape_4_2_1_1_int16_DFPQuantizedTest) {
 
   // nchw
   std::vector<float> golden = {// first channel
-                               18, 22, 21, 8,  7, 9, 8, 3,
+                               18, 22, 21, 8, 7, 9, 8, 3,
                                // second channel
-                               2,  3,  1,  -1, 2, 3, 1, 0,
+                               2, 3, 1, -1, 2, 3, 1, 0,
                                // third channel
-                               5,  6,  6,  4, -1, -2, -2, 1};
+                               5, 6, 6, 4, -1, -2, -2, 1};
 
-  std::vector<int16_t> input_data = {
-    512, 512, 512, 512,
-    1024,1024,1536,1024
-  };
-  std::vector<int16_t> weight_data = {
-    256,512,768,1024,
-    -256,256,-256,256,
-    -256,-256,256,256
-  };
-  std::vector<int64_t> bias_data = {
-    1<<fl_bias, 2*(1<<fl_bias),3*(1<<fl_bias)
-  };
+  std::vector<int16_t> input_data = {512,  512,  512,  512,
+                                     1024, 1024, 1536, 1024};
+  std::vector<int16_t> weight_data = {256,  512, 768,  1024, -256, 256,
+                                      -256, 256, -256, -256, 256,  256};
+  std::vector<int64_t> bias_data = {1 << fl_bias, 2 * (1 << fl_bias),
+                                    3 * (1 << fl_bias)};
 
   auto input_tensor = graph->CreateTensor(input_spec, input_data.data());
   auto weight_tensor = graph->CreateTensor(weight_spec, weight_data.data());
@@ -1894,8 +1893,8 @@ TEST(Conv2d, shape_4_2_1_1_int16_DFPQuantizedTest) {
   std::array<uint32_t, 2> stride({1, 1});
   std::array<uint32_t, 2> dilation({0, 0});
 
-  auto conv2d = graph->CreateOperation<tim::vx::ops::Conv2d>(
-      padding, stride, dilation);
+  auto conv2d =
+      graph->CreateOperation<tim::vx::ops::Conv2d>(padding, stride, dilation);
   (*conv2d)
       .BindInput(input_tensor)
       .BindInput(weight_tensor)
@@ -1916,8 +1915,8 @@ TEST(Conv2d, shape_4_2_1_1_int16_DFPQuantizedTest) {
   EXPECT_TRUE(output_tensor->CopyDataFromTensor(output.data()));
   //transform output(int16) to fp
   std::vector<float> f;
-  for(const auto& q : output){
-    f.push_back( q / (float)((int64_t)1 << fl_output));
+  for (const auto& q : output) {
+    f.push_back(q / (float)((int64_t)1 << fl_output));
   }
   EXPECT_EQ(golden, f);
 }
@@ -1926,7 +1925,7 @@ TEST(Conv2d, kernel_bigger_than_input_SAME) {
   auto ctx = tim::vx::Context::Create();
   auto graph = ctx->CreateGraph();
 
-  tim::vx::ShapeType input_shape({2, 3, 1, 1});  //whcn
+  tim::vx::ShapeType input_shape({2, 3, 1, 1});   //whcn
   tim::vx::ShapeType kernel_shape({3, 2, 1, 1});  //whio
   tim::vx::ShapeType bias_shape({1});
   tim::vx::ShapeType output_shape({2, 3, 1, 1});
@@ -1939,13 +1938,16 @@ TEST(Conv2d, kernel_bigger_than_input_SAME) {
   tim::vx::TensorSpec output_spec(tim::vx::DataType::FLOAT32, output_shape,
                                   tim::vx::TensorAttribute::OUTPUT);
 
-  std::vector<float> input_data = {1.0f, 3.0f, 4.0f, 2.0f, 2.0f, 3.0f,
-                                };
-  std::vector<float> weight = {100.0f, 20.0f, 1.0f, 200.0f, 10.0f, 2.0f,
-                               };
+  std::vector<float> input_data = {
+      1.0f, 3.0f, 4.0f, 2.0f, 2.0f, 3.0f,
+  };
+  std::vector<float> weight = {
+      100.0f, 20.0f, 1.0f, 200.0f, 10.0f, 2.0f,
+  };
   std::vector<float> bias = {500.0f};
-  std::vector<float> golden = {567.0f,  1480.0f, 608.0f,  1370.0f,
-                               543.0f,  760.0f, };
+  std::vector<float> golden = {
+      567.0f, 1480.0f, 608.0f, 1370.0f, 543.0f, 760.0f,
+  };
   auto input_tensor = graph->CreateTensor(input_spec);
   auto weight_tensor = graph->CreateTensor(kernel_spec, weight.data());
   auto bias_tensor = graph->CreateTensor(bias_spec, bias.data());
@@ -1956,7 +1958,9 @@ TEST(Conv2d, kernel_bigger_than_input_SAME) {
   auto op = graph->CreateOperation<tim::vx::ops::Conv2d>(
       tim::vx::PadType::SAME, strides, dilations, 0, tim::vx::DataLayout::WHCN,
       tim::vx::DataLayout::IcWHOc);
-  (*op).BindInputs({input_tensor, weight_tensor, bias_tensor}).BindOutputs({output_tensor});
+  (*op)
+      .BindInputs({input_tensor, weight_tensor, bias_tensor})
+      .BindOutputs({output_tensor});
 
   EXPECT_TRUE(graph->Compile());
 
diff --git a/third_party/half/ChangeLog.txt.license b/third_party/half/ChangeLog.txt.license
new file mode 100644
index 0000000..771b79e
--- /dev/null
+++ b/third_party/half/ChangeLog.txt.license
@@ -0,0 +1,4 @@
+#
+# Copyright (c) 2012-2017 Christian Rau
+# SPDX-License-Identifier: MIT
+#
diff --git a/third_party/half/LICENSE.spdx b/third_party/half/LICENSE.spdx
new file mode 100644
index 0000000..d71fa7d
--- /dev/null
+++ b/third_party/half/LICENSE.spdx
@@ -0,0 +1,7 @@
+PackageName: half
+SPDXID: SPDXRef-half
+FilesAnalyzed: true
+PackageLicenseConcluded: MIT
+PackageLicenseInfoFromFiles: MIT
+PackageLicenseDeclared: MIT
+PackageCopyrightText:<text>Copyright (c) 2012-2017 Christian Rau <rauy@users.sourceforge.net></text>
diff --git a/third_party/half/README.txt.license b/third_party/half/README.txt.license
new file mode 100644
index 0000000..771b79e
--- /dev/null
+++ b/third_party/half/README.txt.license
@@ -0,0 +1,4 @@
+#
+# Copyright (c) 2012-2017 Christian Rau
+# SPDX-License-Identifier: MIT
+#
